(
  status.muf     by Gyroplast   11/08/00   v1.0
  Set a status property to a couple of predefined values like AFK, etc..
 
  Flags: W
 
  SETUP:
    1. Attach an action named 'install' [important!], pref. on room #0.
    2. @link the action to the program
    3. Type 'install' to run the program
    4. Follow the instructions
 
  Caution: The setup will convert the install action into a default
           action for the predefined status values!
 
  To find out how to add new statii [cool plural, huh? ;}] and other
  neet stuff, try 'status #help' after the program has been set up.
 
  http://www.mufarchive.com      -+==+-      gyroplast@gyroplast.com
)
 
$def HEADER "status.muf     by Gyroplast@FuzzyLogic   v1.0"
$def LINE   "---------------------------------------------"
 
$include $FLAPI/FL-API         ( include API functions )
$include $FLAPI/FL-CONF        ( include configuration file )
 
: SetStatus ( [ s --  ] - set status field to s )
  me @ PLR_STATUS_PROP rot 0 addprop
;
 
: StatusExist? ( [ s -- b ] - is s a valid status setting? )
  CONFIG_LOC STATUS_ROOT 
  rot strcat "/allowed?" strcat getpropstr   ( retr. _status/allowed? prop )
  .yes?                                      ( is it set to yes? )
;
 
: GetLongStatus ( [ s -- s' ] - retrieve long status alias )
  GetStatus dup                            ( get and keep copy of status code )
  CONFIG_LOC STATUS_ROOT
  rot strcat "/long" strcat getpropstr        ( retr. _status/long prop )
  dup if                                      ( if alias set? )
    swap                                      ( bring status code s to top)
  then
  pop                                         ( pop it )
;
 
: ShowCurStatus ( [  --  ] - display your current status )
  "You are currently set ["
  GetStatus strcat
  "] - " strcat
  GetLongStatus strcat
  .tell
;
 
: ShowHelp ( [  --  ] - display help screen )
  HEADER .tell
  LINE .tell
  " " .tell
;
 
: Main
  dup not if                      ( no parameter given? )
    ShowCurStatus exit            ( show current status and exit )
  then
;

