LVAR count
: pad
  swap "                                 " strcat swap
  strcut pop
;
: RetrieveDoing ( [ d -- s ] )
  dup player? not if pop "" exit then
  dup "_/do" getpropstr
  dup not if
    pop pop "" exit
  else
    swap
    name 17 pad " : " strcat
    swap strcat
  then    
;
: StoreDoing  ( [ s --  ] )
  dup if
    prog swap
    "_DoingList/" count @ intostr strcat
    swap 0 addprop 
    count @ 1 + count !
  else
    pop
  then
;
: DeleteList
  "Deleting old list..." .tell
  prog "_DoingList" remove_prop
  "DONE." .tell
;
: ListEmpty?
  prog "_DoingList/1" getpropstr not 
;
: ShowList
  "Displaying List:" .tell
  1
  BEGIN
    prog 
    over intostr "_DoingList/" swap strcat
    getpropstr
    dup while
    .tell
    1 +
  REPEAT
  pop 
  "DONE." .tell
;
: BuildList
  "Switching to background mode..." .tell
  background
  "DONE." .tell
 
  1 count !
  "Building new list..." .tell
  1
  BEGIN
    dup dbref
    dup dbtop dbcmp not while
    RetrieveDoing
    StoreDoing
    1 +
  REPEAT
  pop pop
  "DONE." .tell
;
: RebuildList
  DeleteList
  BuildList
  "Rebuild Complete." .tell
;
: ShowHelp
  " " .tell
  "  Usage: " command @ strcat " {#show|#rebuild|#help}" strcat .tell
  " " .tell
  "    #show - Display saved list of doings. Automatically builds a" .tell
  "            new list if none has been built yet." .tell
  " " .tell
  " #rebuild - Delete list if necessary and build a new, updated one." .tell
  " " .tell
  "    #help - Display this help." .tell
  " " .tell
  "    WARNING: Building a list takes a couple of minutes!" .tell
  " " .tell
;
: main
  dup "#s" stringpfx 1 = if              ( #show )
    pop
    ListEmpty? if
      "List is empty. Please be patient while list is build..." .tell
      BuildList
    then
    ShowList exit
  then
 
  dup "#r" stringpfx 1 = if               ( #rebuild )
    pop RebuildList exit
  then
 
  ShowHelp
;

