(*************************************************************************)
(* internet.muf -- An `internet' for IC boards and mailing system        *)
(*************************************************************************)
(* By: Steve Conley, Anne@Frontiers, tanabi@bellsouth.net                *)
(*************************************************************************)
(* There's a #help feature that tells you how to set it up.  Link an     *)
(* action and read it.  This includes LSEdit from the FB5.56 MUF pack;   *)
(* I take no credit for that. [Foxen's program?  I dunno]                *)
(*************************************************************************)
$def .xansplit .split
(
Functionality:
What I want to add:
chess and calculator
)
(* Where are the names of the computers located? *)
$def dns #804
(* And where is the public bulletin board? *)
$def bb #793
(* Just a def to help me out -- do not change *)
$def cc comp @
( This is LSEdit from FB5.56's MUF pack... )
$include $lib/lmgr
$include $lib/editor
$include $lib/strings
$def LMGRgetcount lmgr-getcount
$def LMGRgetrange lmgr-getrange
$def LMGRputrange lmgr-putrange
$def LMGRdeleterange lmgr-deleterange
: LMGRdeletelist
  over over LMGRgetcount
  1 4 rotate 4 rotate LMGRdeleterange
;
 
 : LMGRgetlist
  over over LMGRgetcount
  rot rot 1 rot rot
  LMGRgetrange
;
: lsedit-loop  ( listname dbref {rng} mask currline cmdstr -- )
    EDITORloop
    dup "save" stringcmp not if
        pop pop pop pop
        3 pick 3 + -1 * rotate
        over 3 + -1 * rotate
        dup 5 + pick over 5 + pick
        over over LMGRdeletelist
        1 rot rot LMGRputrange
        4 pick 4 pick LMGRgetlist
        dup 3 + rotate over 3 + rotate
        "< List saved. >" .tell
        "" lsedit-loop exit
    then
    dup "abort" stringcmp not if
        "< list not saved. >" .tell
        pop pop pop pop pop pop pop pop pop exit
    then
    dup "end" stringcmp not if
        pop pop pop pop pop pop
        dup 3 + rotate over 3 + rotate
        over over LMGRdeletelist
        1 rot rot LMGRputrange
        "< list saved. >" .tell exit
    then
;
lvar i
lvar tmp
lvar blah
: cmd-lsedit (listname dbref)
    dup blah ! swap dup tmp ! swap 
"<    Welcome to the list editor.  You can get help by entering '.h'     >"
.tell
"< '.end' will exit and save the list.  '.abort' will abort any changes. >"
.tell
"<    To save changes to the list, and continue editing, use '.save'     >"
.tell
    over over LMGRgetlist
    "save" 1 ".i $" lsedit-loop
    1 i !
    begin
      blah @ tmp @ "#/" strcat i @ intostr strcat getpropstr strlen while
      i @ 1 + i !
    repeat
    blah @ tmp @ "#" strcat i @ 1 - intostr setprop
;
( End lsedit )
var return  ( Return address )
var comp    (Computer's dbref)
var uid     ( User identity  )
var cwd     ( Current dir    )
(**************************TOPICS*****************************************)
: board_topic_list ( Board topic list )
  "-- Listing Current Bulletin Board Topics --" .tell
  bb "topics/" nextprop
  begin
    dup strlen while
    dup
    7 strcut swap pop
    dup "#" instring if
      "#" .xansplit pop
    then
    .tell
    bb swap nextprop
  repeat
  pop
  "-- Listing Complete --" .tell
;
: board_topic_add
  "--> Adding a new topic to the Bulletin Board System <--" .tell
  " " .tell
  "Type in the name of the topic, or a `.' by itself to abort." .tell
  read
  dup "." strcmp not if
    "-- Aborted --" .tell pop exit
  then
  dup
  bb swap
  "topics/" swap strcat "#" strcat "0" setprop
  bb swap "topics/" swap strcat "#/.pword" strcat
  "Type in the password for this topic.  You need this password to control" .tell
  "the topic; if you forget it, ask the owner of this program to help." .tell
  read setprop
  "-- Done --" .tell
;
: board_topic_erase
  "--> Removing a topic -- Requires a password! <--" .tell
  " " .tell
  "Type in the name of the topic, or a `.' by itself to abort." .tell
  read
  dup "." strcmp not if
    "-- Aborted --" .tell pop exit
  then
  dup bb swap "topics/" swap strcat "#/.pword" strcat getpropstr
  "Type in the topic password:" .tell
  read strcmp if
    pop "Sorry, bud!" .tell exit
  then
  bb swap "topics/" swap strcat "#" strcat remove_prop
  "-- Topic deleted --" .tell
;
(*******************************Board Messages******************************)
lvar num
lvar topic
: board_message_list ( s -- ) ( `s' is topic )
  topic !
  "-- Listing: " topic @ strcat " --" strcat .tell
  1 num !
  begin
    bb "topics/" topic @ strcat "#" strcat getpropstr atoi num @ >= while
    bb "topics/" topic @ strcat "#/" strcat num @ intostr strcat
    "#/.tombstone" strcat getpropstr strlen not if
      num @ intostr ": " strcat
      bb "topics/" topic @ strcat "#/" strcat num @ intostr strcat
      "#/.subject" strcat getpropstr strcat
      " (by " strcat
      bb "topics/" topic @ strcat "#/" strcat num @ intostr strcat
      "#/.poster" strcat getpropstr strcat " at " strcat
      bb "topics/" topic @ strcat "#/" strcat num @ intostr strcat
      "#/.date" strcat getpropstr strcat ")" strcat .tell
    then
    num @ 1 + num !
  repeat
  "-- Finished Listing --" .tell
;
lvar msg
lvar topic
lvar i
: board_message_read ( s i -- ) ( `s' is topic, `i' is message number )
  msg ! topic !
  bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat
  "#/.tombstone" strcat getpropstr strlen if
    "--> That message has been deleted; sorry!" .tell exit
  then
  "-- Listing message " msg @ intostr strcat " --" strcat .tell
  "By: " bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat
  "#/.poster" strcat getpropstr strcat " at " strcat
  bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat "#/.date" strcat
  getpropstr strcat .tell
  "Subject: " bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat
  "#/.subject" strcat getpropstr strcat .tell
  1 i !
  begin
    bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat "#" strcat
    getpropstr atoi i @ >= while
    bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat "#/" strcat
    i @ intostr strcat getpropstr .tell
    i @ 1 + i !
    i @ 19 % not if
      "<Hit Any Key Then Enter To Continue>" .tell read pop
    then
  repeat
  "-- Done --" .tell
  "<Hit Any Key Then Enter To Continue>" .tell read pop
;
lvar msg
lvar topic
: board_message_delete ( s i -- ) ( `s' is topic, `i' is message )
  msg ! topic !
  bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat
  "#/.poster" strcat getpropstr
  return @ strcmp if
    "--> What is the password for this newsgroup?" .tell
    read
    bb "topics/" topic @ strcat "#/.pword" strcat getpropstr strcmp if
      "-- Wrong password, You can't delete this message --" .tell exit
    then
  then
  bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat
  "#" strcat remove_prop
  bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat
  "#/.tombstone" strcat "yes" setprop
  "-- Deleted --" .tell
;
lvar msg
lvar topic
lvar lines
lvar subj
: board_message_write ( `s' -- Topic )
  topic !
  "-- What is the topic of this message?  Use `.' to abort writing --" .tell
  read
  dup "." strcmp not if
    pop "-- Aborted --" .tell exit
  then
  subj !
  bb "topics/" topic @ strcat "#" strcat propdir? not if
    "-- That's not a valid topic --" .tell exit
  then
  1 msg !
  begin
    bb "topics/" topic @ strcat "#" strcat getpropstr atoi msg @ >= while
    bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat
    "#/.tombstone" strcat getpropstr strlen if
      bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat "#" strcat
      remove_prop
      break
    then
    msg @ 1 + msg !
  repeat
  bb "topics/" topic @ strcat "#" strcat getpropstr atoi msg @ < if
    bb "topics/" topic @ strcat "#" strcat msg @ intostr setprop
  then
  bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat "#/.subject"
  strcat subj @ setprop
  bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat "#/.poster"
  strcat return @ setprop
  bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat "#/.date"
  strcat "%T %C" systime timefmt setprop
  "Type in the message below.  End with a `.' on a line by itself." .tell
  0 lines !
  begin
    read
    dup "." strcmp not if
      pop bb "topics/" topic @ strcat "#/" strcat msg @ intostr strcat "#"
      strcat lines @ intostr setprop
      "-- Done --" .tell exit
    then
    lines @ 1 + lines !
    bb swap "topics/" topic @ strcat "#/" strcat msg @ intostr strcat
    "#/" strcat lines @ intostr strcat swap setprop
  repeat
;
(*****************************DNS STUFF***********************************)
: getDbrefFromName ( s -- d ) ( Takes hostname, gets dbref of computer )
  dns swap "_hosts/" swap strcat getpropstr atoi dup if
    dbref
    dup ok? not if
      pop #-1 exit
    then
    exit
  then
  #-1
;
: register_host ( s -- ) ( Registers your host )
  dup
  dns swap "_hosts/" swap strcat getpropstr strlen if
    pop "--> That hostname is taken <--" .tell exit
  then
  dup
  dns swap "_hosts/" swap strcat comp @ intostr setprop
  cc swap "_hostname" swap setprop
  "--> Hostname registered <--"
;
(*****************************EMAIL STUFF***********************************)
( Email stuff is a variant of bulletin boards -- It's a bulletin board with
  one topic, essentially )
lvar num
: email_message_list ( Email list )
  "-- Listing Currently Stored Email Messages --" .tell
  1 num !
  begin
    cc "email/" uid @ strcat "#" strcat getpropstr atoi num @ >= while
    cc "email/" uid @ strcat "#/" strcat num @ intostr strcat
    "#/.tombstone" strcat getpropstr strlen not if
      num @ intostr ": " strcat
      cc "email/" uid @ strcat "#/" strcat num @ intostr strcat
      "#/.subject" strcat getpropstr strcat
      " (by " strcat
      cc "email/" uid @ strcat "#/" strcat num @ intostr strcat
      "#/.poster" strcat getpropstr strcat " at " strcat
      cc "email/" uid @ strcat "#/" strcat num @ intostr strcat
      "#/.date" strcat getpropstr strcat ")" strcat .tell
    then
    num @ 1 + num !
  repeat
  "-- Finished Listing --" .tell
;
lvar msg
lvar i
: email_message_read ( i -- ) ( `i' is message number )
  msg !
  cc "email/" uid @ strcat "#/" strcat msg @ intostr strcat
  "#/.tombstone" strcat getpropstr strlen if
    "--> That message has been deleted; sorry!" .tell exit
  then
  "-- Listing message " msg @ intostr strcat " --" strcat .tell
  "By: " cc "email/" uid @ strcat "#/" strcat msg @ intostr strcat
  "#/.poster" strcat getpropstr strcat " at " strcat
  cc "email/" uid @ strcat "#/" strcat msg @ intostr strcat "#/.date" strcat
  getpropstr strcat .tell
  "Subject: " cc "email/" uid @ strcat "#/" strcat msg @ intostr strcat
  "#/.subject" strcat getpropstr strcat .tell
  1 i !
  begin
    cc "email/" uid @ strcat "#/" strcat msg @ intostr strcat "#" strcat
    getpropstr atoi i @ >= while
    cc "email/" uid @ strcat "#/" strcat msg @ intostr strcat "#/" strcat
    i @ intostr strcat getpropstr .tell
    i @ 1 + i !
    i @ 19 % not if
      "<Hit Any Key Then Enter To Continue>" .tell read pop
    then
  repeat
  "-- Done --" .tell
  "<Hit Any Key Then Enter To Continue>" .tell read pop
;
lvar msg
: email_message_delete ( i -- ) ( `i' is message )
  msg !
  cc "email/" uid @ strcat "#/" strcat msg @ intostr strcat
  "#" strcat remove_prop
  cc "email/" uid @ strcat "#/" strcat msg @ intostr strcat
  "#/.tombstone" strcat "yes" setprop
  "-- Deleted --" .tell
;
lvar person
lvar msg
lvar lines
lvar subj
lvar targ
: email_message_write ( d s -- Target person )
  targ ! person !
  "-- What is the topic of this message?  Use `.' to abort writing --" .tell
  read
  dup "." strcmp not if
    pop "-- Aborted --" .tell exit
  then
  subj !
  1 msg !
  begin
    targ @ "email/" person @ strcat "#" strcat getpropstr atoi msg @ >= while
    targ @ "email/" person @ strcat "#/" strcat msg @ intostr strcat
    "#/.tombstone" strcat getpropstr strlen if
      targ @  "email/" person @ strcat "#/" strcat msg @ intostr strcat "#" strcat
      remove_prop
      break
    then
    msg @ 1 + msg !
  repeat
  targ @ "email/" person @ strcat "#" strcat getpropstr atoi msg @ < if
    targ @ "email/" person @ strcat "#" strcat msg @ intostr setprop
  then
  targ @  "email/" person @ strcat "#/" strcat msg @ intostr strcat "#/.subject"
  strcat subj @ setprop
  targ @  "email/" person @ strcat "#/" strcat msg @ intostr strcat "#/.poster"
  strcat return @ setprop
  targ @  "email/" person @ strcat "#/" strcat msg @ intostr strcat "#/.date"
  strcat "%T %C" systime timefmt setprop
  "Type in the message below.  End with a `.' on a line by itself." .tell
  0 lines !
  begin
    read
    dup "." strcmp not if
      pop targ @ "email/" person @ strcat "#/" strcat msg @ intostr strcat "#"
      strcat lines @ intostr setprop
      targ @ "email/" person @ strcat "#/.newmail" strcat "yes" setprop
      "-- Done --" .tell exit
    then
    lines @ 1 + lines !
    targ @ swap "email/" person @ strcat "#/" strcat msg @ intostr strcat
    "#/" strcat lines @ intostr strcat swap setprop
  repeat
;
(***************************File stuff*******************************)
lvar cutoff
: file_list_directory
  "Listing directories ... public" .tell
  cc cwd @ "/public/" strcat dup strlen cutoff ! nextprop
  begin
    dup strlen while
    dup cutoff @ strcut swap pop "#" .xansplit pop
    .tell
    cc swap nextprop
  repeat
  pop
  "------------------------------" .tell
  "Listing directories .. private" .tell
  cc cwd @ "/private/" strcat dup strlen cutoff ! nextprop
  begin
    dup strlen while
    dup cutoff @ strcut swap pop "#" .xansplit pop
    .tell
    cc swap nextprop
  repeat
  pop
  "(Done)------------------------" .tell
;
lvar fname
: file_edit_file
  "First, would you like this to be a [1] Public or [2] Private file?" .tell
  "Please type `1' or `2' below." .tell
  read
  atoi
  1 = if
    cwd @ "/public/" strcat fname !
    else
      cwd @ "/private/" strcat fname !
  then
  "Next, what would you like to call this file?  Please use only numbers and" .tell
  "letters in the name -- any other characters could cause problems." .tell
  fname @ read strcat
  cc cmd-lsedit
;
lvar fname
lvar i
: file_read_file ( -- )
  "Is this a [1] public or [2] private file?" .tell
  "Please type `1' or `2' below." .tell
  read
  atoi
  1 = if
    cwd @ "/public/" strcat fname !
    else
      cwd @ "/private/" strcat fname !
  then
  "What is the name of this file?" .tell
  fname @ read strcat fname !
  1 i !
  begin
    cc fname @ "#" strcat getpropstr atoi i @ >= while
    cc fname @ "#/" strcat i @ intostr strcat getpropstr .tell
    i @ 1 + i !
    i @ 19 % not if
      "<Hit Any Key Then Enter To Continue>" .tell read pop
    then
  repeat
  "-- Done --" .tell
  "<Hit Any Key Then Enter To Continue>" .tell read pop
;
: file_delete_file ( -- )
  "Is this a [1] public or [2] private file?" .tell
  "Please type `1' or `2' below." .tell
  read
  atoi
  1 = if
    cwd @ "/public/" strcat fname !
    else
      cwd @ "/private/" strcat fname !
  then
  "What is the name of the file you want to delete?" .tell
  fname @ read strcat fname !
  cc fname @ "#" strcat remove_prop
  "File deleted." .tell
;
lvar targ
lvar src
lvar dest
lvar i
lvar tmpid
: file_xfer ( -- )
  "Preparing to do a file transfer.  First, tell me the computer you want" .tell
  "to `connect' to. (ex. chaos.anne.mobile.net)" .tell
  read getDbrefFromName
  dup ok? not if
    pop "> Sorry, there is no computer registered to that name." .tell
    exit
  then
  targ !
  "Please type in the username of the person you want to upload files from." .tell
  read
  tmpid !
  "Please type in that person's password if you want to upload private files," .tell
  "or type `public' to access their public files." .tell
  read dup "public" strcmp not if
    pop "/" tmpid @ strcat "/public/" strcat src !
    else
      targ @ "_passwd/" tmpid @ strcat getpropstr strcmp if
        "Sorry, that password is incorrect." .tell exit
      then
      "/" tmpid @ strcat "/private/" strcat src !
  then
  "You are now connected.  There's two commands you can use; `get' and `ls'." .tell
  "`get' will upload files, `ls' will list the files.  You can also `exit' at" .tell
  "any time." .tell
  begin
    read
    dup "ls" strcmp not if
      pop "Directory Listing:" .tell
      targ @ src @ nextprop
      begin
        dup strlen while
        dup src @ strlen strcut swap pop "#" .xansplit pop
        .tell
        targ @ swap nextprop
      repeat
      pop
      "(Done)" .tell
      else dup "get" strcmp not if
        pop "Type in the filename to upload below." .tell
        src @ read "#" strcat strcat
        "Would you like to upload this to your [1]public or [2]private dir?" .tell
        read atoi
        1 = if
          cwd @ "/public/" strcat dest !
          else
            cwd @ "/private/" strcat dest !
        then
        "What name do you want to call it on your system?" .tell
        dest @ read strcat "#" strcat dest !
        1 i !
        begin
          dup targ @ swap getpropstr atoi i @ >= while
          dup "/" strcat i @ intostr strcat targ @ swap getpropstr
          cc swap dest @ "/" strcat i @ intostr strcat swap setprop
          i @ 1 + i !
        repeat
        pop
        cc dest @ i @ intostr setprop
        "Transfer complete." .tell
        else dup "exit" strcmp not if
          pop "Closing connection." .tell exit
          else
            pop "Sorry, that's not a valid command." .tell
        then
      then
    then
  repeat
;
(****************************HACKING FILES***************************)
lvar targ
lvar src
lvar dest
lvar i
lvar tmpid
: do_hack
  me @ "@hacker" getpropstr tolower "yes" strcmp if
    "You mess around a little, but can't get anywhere cause you don't have the knowhow." .tell
    exit
  then
  "*WARNING* You are about to try and hack a system.  If you fail, the party" .tell 
  "you're trying to hack will know it, and you will probably get in trouble" .tell
  "ICly if you do that (You will not get in trouble OOC; this is a purely" .tell
  "IC device)" .tell
  " " .tell
  "Press any key then enter to continue, or `.' by itself then enter to abort." .tell
  read "." strcmp not if
    "Aborted.  No harm done." .tell exit
  then
  "Type in the address of the system to hack." .tell
  read
  getDbrefFromName dup ok? not if
    pop "That's not a registered computer, sorry." .tell exit
  then
  targ !
  "Analyzing the system, you guess it to be security level "
  targ @ "~security" getpropstr atoi intostr strcat "." strcat .tell
  "Continue?  (Y/n)" .tell
  read
  tolower
  "n" strcmp not if
    "Aborting.  No harm done." .tell exit
  then
  "Who's account do you want to hack on this system?" .tell
  "/" read strcat "/private/" strcat src !
  targ @ "~security" getpropstr atoi
  random 100 % > if
    "*** HACKING ATTEMPT FAILED ***" .tell
    targ @ owner awake? if
      targ @ owner me @ name " tried to hack " strcat targ @ name strcat "!" strcat notify
      exit
    then
    targ @ owner "p #mail " targ @ owner name strcat "=" strcat
    me @ name strcat " tried to hack into " targ @ name strcat "!" strcat
    force
    exit
  then
  "You've successfully hacked into this system.  You can use `ls' to list" .tell
  "the directory, `get' to upload a file, and `exit' to disconnect." .tell
  begin
    read
    dup "ls" strcmp not if
      pop "Directory Listing:" .tell
      targ @ src @ nextprop
      begin
        dup strlen while
        dup src @ strlen strcut swap pop "#" .xansplit pop
        .tell
        targ @ swap nextprop
      repeat
      pop
      "(Done)" .tell
      else dup "get" strcmp not if
        pop "Type in the filename to upload below." .tell
        src @ read "#" strcat strcat
        "Would you like to upload this to your [1]public or [2]private dir?" .tell
        read atoi
        1 = if
          cwd @ "/public/" strcat dest !
          else
            cwd @ "/private/" strcat dest !
        then
        "What name do you want to call it on your system?" .tell
        dest @ read strcat "#" strcat dest !
        1 i !
        begin
          dup targ @ swap getpropstr atoi i @ >= while
          dup "/" strcat i @ intostr strcat targ @ swap getpropstr
          cc swap dest @ "/" strcat i @ intostr strcat swap setprop
          i @ 1 + i !
        repeat
        pop
        cc dest @ i @ intostr setprop
        "Transfer complete." .tell
        else dup "exit" strcmp not if
          pop "Closing connection." .tell exit
          else
            pop "Sorry, that's not a valid command." .tell
        then
      then
    then
  repeat
;
: secure
  me @ cc owner dbcmp not if
    "Only the owner of the system can secure it." .tell exit
  then
  "This will determine how `hackable' your system is.  The security level" .tell
  "of your system is a number between 0 and 100; this number is the percent" .tell
  "chance that your system will be cracked into with any given attempt.  Note" .tell
  "that even if you have 100% security, you still have a 1 in 100 chance of" .tell
  "still getting broken into, though obviously that is very rare." .tell
  " " .tell
  "If a hacker is thwarted, you will be notified if you are currently online," .tell
  "or you will be p #mail'd if you are not online.  You can then take whatever" .tell
  "IC measures you see fit as punishment." .tell
  "<Hit any key than enter to continue>" .tell
  read pop
  "Now, you are currently at security level "
  cc "~security" getpropstr atoi intostr strcat "." strcat .tell
  "How many points do you want to add?  Each security point costs 10 credits." .tell
  "You have " me @ pennies intostr strcat " credits." strcat .tell
  read
  atoi
  dup 10 * me @ pennies > if
    pop "Sorry, you can't afford that." .tell exit
  then
  dup cc "~security" getpropstr atoi + 100 > if
    pop "Sorry, that pushes you over 100% security." .tell exit
  then
  dup cc swap "~security" swap cc "~security" getpropstr atoi + intostr setprop
  10 * 0 swap - me @ swap addpennies
  "Security level set." .tell
;
(**************************`Computer' interface**********************)
: login
  "######################################################################" .tell
  "# Welcome to VOS1.0R4[Virtual Operating System].  Please login below #" .tell
  "######################################################################" .tell
  " " .tell
  " " .tell
  cc "_hostname" getpropstr " login:" strcat .tell
  read
  uid !
  "Password:" .tell
  read
  cc "_passwd/" uid @ strcat getpropstr strcmp if
    "-- Login incorrect.  Sorry! --" .tell 0 exit
  then
  1 exit
;
: do_mail
  cc "email/" uid @ strcat "#/.newmail" strcat "no" setprop
  begin
    "[Commands: [L]ist | [W]rite | [R]ead | [D]elete | [Q]uit ]" .tell
    read tolower
    dup "l" strcmp not if
      pop email_message_list
      else dup "w" strcmp not if
        pop "Type in the address of receiving party:" .tell
        read
        dup "@" instring if
          "@" .xansplit
      else "Not a valid email adress!" .tell exit
        then
        getDbrefFromName
        dup ok? not if
          pop "Couldn't resolve host!" .tell
          else
            email_message_write
        then
        else dup "r" strcmp not if
          pop "Which message?" .tell read atoi email_message_read
          else dup "d" strcmp not if
            pop "Which message?  Use '.' by itself to abort." .tell
            read
            dup "." strcmp not if
              pop "Aborted" .tell
              else
                atoi email_message_delete
            then
            else dup "q" strcmp not if
              pop "-- Exiting --" .tell exit
              else
                pop "What?!" .tell
            then
          then
        then
      then
    then
  repeat
;
: do_board
  begin
    "[Commands: [L]ist Topics | [P]ick Topic | [T]opic Edit | [Q]uit ]" .tell
    read tolower
    dup "l" strcmp not if
      pop board_topic_list
      else dup "p" strcmp not if
        pop "Which topic do you want to browse?" .tell
        read
        me @ swap "_vostmp/topic" swap setprop
        begin
          "[Commands: [L]ist | [P]ost | [D]elete | [R]ead | [T]opics Menu ]" .tell
          read tolower
          dup "l" strcmp not if
            pop me @ "_vostmp/topic" getpropstr
            board_message_list
            else dup "p" strcmp not if
              pop me @ "_vostmp/topic" getpropstr
              board_message_write
              else dup "d" strcmp not if
                pop me @ "_vostmp/topic" getpropstr
                "Which message would you like to delete?" .tell read atoi
                board_message_delete
                else dup "r" strcmp not if
                  pop me @ "_vostmp/topic" getpropstr
                  "Which message would you like to read?" .tell read atoi
                  board_message_read
                  else dup "t" strcmp not if
                    pop break
                    else
                      pop "Wha...?" .tell
                  then
                then
              then
            then
          then
        repeat
        else dup "t" strcmp not if
          pop "[Commands: [A]dd a topic | [D]elete a topic | [N]othing ]" .tell
          read tolower
          dup "a" strcmp not if
            pop board_topic_add
            else dup "d" strcmp not if
              pop board_topic_erase
            then
          then
          else dup "q" strcmp not if
            pop "Done." .tell exit
            else
              pop "Wha?" .tell
          then
        then
      then
    then
  repeat
;
: do_name
  "Type in the full name you want for your computer.  It will from now" .tell
  "on be known by this name--please do not change it!" .tell
  read
  register_host
;
: online_help
  "----------------------------------------------------------" .tell
  "The following commands work on the current version of VOS:" .tell
  "----------------------------------------------------------" .tell
  "mail                           Sends email to that address" .tell
  "board                          Enter the bulletin board   " .tell
  "adduser                        Add a user to your system  " .tell
  "passwd                         Change your password       " .tell
  "logout                         Exit the system            " .tell
  "----------------------------------------------------------" .tell
  "The following commands are for working with files:        " .tell
  "----------------------------------------------------------" .tell
  "edit                           Edit/create a file         " .tell
  "delete                         Delete a file              " .tell
  "read                           Read a file                " .tell
  "ls                             List the directories       " .tell
  "ftp                            File transfer              " .tell
  "----------------------------------------------------------" .tell
  "The following commands are for computer security measures:" .tell
  "----------------------------------------------------------" .tell
  "secure                         Purchase security          " .tell
  "hack                           Hack into a system         " .tell
  "----------------------------------------------------------" .tell
;
: adduser
  cc owner me @ dbcmp not if
    "Only the owner of the computer object can add users--sorry!" .tell exit
  then
  cc "_passwd/"
  "Type in the username of the person to add in below, or use `.' by itself" .tell
  "to abort.  Please do not use `@' symbols in usernames--otherwise, any" .tell
  "character is legal including spaces [though I would suggest you keep the" .tell
  "user id's short].  Also, `/' is forbidden." .tell
  read
  dup "." strcmp not if
    pop "Aborted!" .tell exit
  then
  dup "@" instring if
    pop "Can't have @ symbols in usernames." .tell exit
  then
  dup "/" instring if
    pop "Can't have / symbols in usernames." .tell exit
  then
  strcat
  "Type in the password for this user.  This should probably be something" .tell
  "like `changeme'.  Make sure to direct the user to the `passwd' command so" .tell
  "that he/she can change his/her password." .tell
  read
  setprop
  "User added!" .tell
;
: passwd
  uid @ "guest" stringcmp not if "Guests cannot change their password!" .tell exit then
  "Now changing your password.  First, type in your old pasword..." .tell
  cc "_passwd/" uid @ strcat getpropstr
  read
  strcmp if
    "Sorry, that's incorrect." .tell exit
  then
  cc "_passwd/" uid @ strcat
  "What would you like to change it to?" .tell
  read setprop
  "Changed!" .tell
;
  
: setup_help
  "======================================================================" .tell
  "Virtual Operating System V1.0R4 by Steve Conley [Anne atta Frontiers!]" .tell
  "======================================================================" .tell
  "This is a Virtual Operating System which simulates various aspects of " .tell
  "a RL computer.  It's for IC purposes, namely to send email, post to   " .tell
  "boards, and that sort of thing.  Soon support for files, file transfer" .tell
  "and computer hacking will be supported--that'll be in the near future." .tell
  "----------------------------------------------------------------------" .tell
  "Type the following to set it up:                                      " .tell
  "@create <computer object name>  IE  @create Computer Terminal         " .tell
  "@act login=<computer object name>,$vos   IE @act login=terminal,$vos  " .tell
  "@set <computer object name>=_passwd/<loginid>:<password>              " .tell
  "login      and type in your login id and password as indicated        " .tell
  "----------------------------------------------------------------------" .tell
  "After you have done that, you can just 'login' whenever you need.     " .tell
  "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-" .tell
  "!NEW: Please read `vos #privacy' for information on files and file   !" .tell
  "!privacy.  Please read it before using files on this system!         !" .tell
  "======================================================================" .tell
;
: help_privacy
  "======================================================================" .tell
  "VOS is not a secure system, and as such, don't expect any email or    " .tell
  "files you put on this system to be 100% private.  At the very least,  " .tell
  "the person who owns the computer object and all wizards will be able  " .tell
  "to see all mail and files on this system.  Also, this system allows   " .tell
  "for IC `hacking', thus meaning any files you designate as `private'   " .tell
  "can be potentially viewed by other people.  Please do not put any     " .tell
  "secret, delicate, or otherwise private information on this system.    " .tell
  "This is just a toy for roleplay use; a prop, if you will, for TPs.    " .tell
  "Please realise this and treat it as such.                             " .tell
  "----------------------------------------------------------------------" .tell
  "Note that you can have a level of security against hacking (but not   " .tell
  "against bad wizards and corrupt sysadmins).  Type `secure' when you've" .tell
  "logged into your VOS system.  You can only secure systems you own.    " .tell
  "======================================================================" .tell
;
: main
  tolower "#privacy" strcmp not if
    help_privacy exit
  then
  trigger @ location comp !
  command @ tolower "vos" strcmp not if
    setup_help exit
  then
  login not if
    exit
  then
  cc "_hostname" getpropstr strlen not if
    do_name
  then
  cc "_hostname" getpropstr uid @ "@" strcat swap strcat return !
  "/" uid @ strcat cwd ! 
  "VOS V1.0R4 by Anne McConner of Lylac I.  [anne@chaos.anne.mobile.net]" .tell
  "Type `?' for help." .tell
  cc "email/" uid @ strcat "#/.newmail" strcat getpropstr "yes" strcmp not if
    "You have new mail.  Type `mail' to enter the mail browser." .tell
  then
  begin
    "[%X] Type in your command now:" systime timefmt .tell
    read
    dup "?" strcmp not if
      pop online_help
      else dup "logout" strcmp not if
        pop "Signing off!" .tell exit
        else dup "name" strcmp not if
          pop do_name
          cc "_hostname" getpropstr uid @ "@" strcat swap strcat
          else dup "board" strcmp not if
            pop do_board
            else dup "mail" strcmp not if
              pop do_mail
              else dup "adduser" strcmp not if
                pop adduser
                else dup "passwd" strcmp not if
                  pop passwd
                  else dup "edit" strcmp not if
                    pop file_edit_file
                    else dup "ls" strcmp not if
                      pop file_list_directory
                      else dup "delete" strcmp not if
                        pop file_delete_file
                        else dup "read" strcmp not if
                          pop file_read_file
                          else dup "ftp" strcmp not if
                            pop file_xfer
                            else dup "secure" strcmp not if
                              pop secure
                              else dup "hack" strcmp not if
                                pop do_hack
                                else
                                  pop "What?  Type `?' for help." .tell
                              then
                            then
                          then
                        then
                      then
                    then
                  then
                then
              then
            then
          then
        then
      then
    then
  repeat
;

