(
  HOMEDB.MUF     by Gyroplast  02/01/99
  Create and maintain a list of homes to allow easier access.
  SETUP:
  ~~~~~~
    1. Change the $define below the header to represent
       the correct db of the database object, ie. the
       object that is used to host a property tree
       with the $defined name. Must be a valid object.
       If you need to, change the listprop define to
       use a wiz-only property, ie. "@homelist/".
       Remember to wizbit the program after that.
 
    2. Change the 2nd $define to the program number of
       your lsedit program.
 
    3. Change the 3rd $define to the dbrefs of the list's
       maintainers. The first entry will be shown in the
       headline.
 
    4. Set the program W.
 
    5. Link an action { name is irrelevant } to this
       program, set the program 'L' if needed.
       The action should be global.
 
    6. Run the action. If you are defined as a maintainer,
       you'll be able to edit entries, anyone else is only
       able to see the list and detailed info.
 
    7. Have phun!
 
)
 
$def dbase #4601            ( Change this to database's dbref# )
$def lsedit #27             ( Change this to the cmd-lsedit program# )
$def maintainer "13615 3494"  ( Dbref's of maintainers )
$def listprop "homelist/"   ( The name of the used proplist )
$def version "v1.10"        ( Current version )
 
$def lines BEGIN dup while " " .tell 1 - REPEAT pop
$def ismaintainer? intostr maintainer swap instr
 
lvar str
lvar no
lvar n
lvar tp
lvar ptc
 
: pad
  swap "                                                            "
  strcat swap strcut pop
;
 
: existentry?
  dbase swap listprop swap intostr strcat propdir?
;
 
: getnewnumber
  "1"
  BEGIN
   dbase over listprop swap strcat propdir? not if
    atoi break
   else
    atoi 1 + intostr
   then
  REPEAT
;
 
: do-teleport ( [ s --  ] - Run tport from within main list )
  "Attempting teleport..." .tell
  me @ swap force
;
 
: showdetails
  1 lines
  "Detailed information on #" over strcat ": " strcat
  over listprop swap strcat "/name" strcat dbase swap getpropstr
  strcat .tell
  1 lines
 
  dbase swap
  listprop swap strcat
 
  over over "/tport" strcat getpropstr dup tp !
  dup not if pop "NO TPORT!" then
  "Teleporting destination: " swap strcat .tell
 
  over over "/contact" strcat getpropstr
  atoi
  dup not if pop "NO ONE!" else dbref name then
  "Person to contact: " swap strcat .tell
  1 lines
  "Description:" .tell
  swap pop
  "/desc#" strcat
  dbase over propdir? not if
   pop "NO DESCRIPTION AVAILABLE" .tell
  else
  "/" strcat
   1
   BEGIN
    over over
    intostr strcat dbase swap getpropstr dup while
    .tell
    1 +
   REPEAT
   pop pop pop
  then
  1 lines
  "    --=[ Any key to leave, or 't' to teleport to this location ]=--" .tell
  READ strip
  dup "t" stringpfx 1 = if 
    tp @ not if
      "No teleport location found. Leaving..." .tell
    else
      tp @ do-teleport
    then
  then
  pop
;
 
: delentry
  1 lines
  "Are you sure you want to delete entry #" over intostr strcat
  over intostr listprop swap strcat dbase swap "/name" strcat getpropstr
  ")? (y/n)" strcat " (" swap strcat strcat .tell
  READ STRIP tolower
  "y" stringpfx 1 = if
   "Deleting..." .tell
   BEGIN
    dbase over intostr listprop swap strcat "/name" strcat
    dbase 4 pick 1 + intostr listprop swap strcat "/name" strcat
    getpropstr
    dup not if pop pop break then
    0 ADDPROP
 
    dbase over intostr listprop swap strcat "/tport" strcat
    dbase 4 pick 1 + intostr listprop swap strcat "/tport" strcat
    getpropstr 0 ADDPROP
 
    dbase over intostr listprop swap strcat "/contact" strcat
    dbase 4 pick 1 + intostr listprop swap strcat "/contact" strcat
    getpropstr 0 ADDPROP
 
    dbase over intostr listprop swap strcat "/desc#" strcat
    dbase 4 pick 1 + intostr listprop swap strcat "/desc#" strcat
    getpropstr 0 ADDPROP
 
    1
    BEGIN
     over listprop swap 1 + intostr strcat "/desc#/" strcat over intostr
     strcat dbase swap getpropstr dup not if pop pop break then
     3 pick intostr listprop swap strcat "/desc#/" strcat 3 pick intostr
     strcat
     swap dbase -3 rotate 0 ADDPROP
     1 +
    REPEAT 
    1 +
   REPEAT
   getnewnumber 1 - intostr listprop swap strcat remove_prop
   "Entry successfully removed." .tell
  else pop then 
;
 
: addentry
 BEGIN
  getnewnumber no !
  3 lines
  "Add a new entry to the list; Type '.' at any time to abort." .tell
  1 lines
  "Please enter name of location, or a dbref# to use the set name:" .tell
  READ STRIP
  dup "." stringpfx 1 = if pop break then
  dup "#" stringpfx 1 = if 1 strcut swap pop then
  dup atoi if
   dup atoi dbref dup ok? over #0 dbcmp not and over room? and if
    name swap pop
   else
    pop
   then
  then
  n !
 
  "Please enter teleport command:" .tell
  READ STRIP
  dup "." stringpfx 1 = if pop break then
  tp !
 
  "Please enter name of player to contact, or a dbref#:" .tell
  READ STRIP
  dup "." stringpfx 1 = if pop break then
  dup "#" stringpfx 1 = if 1 strcut swap pop then
  dup atoi if
   dup atoi dbref dup ok? over #0 dbcmp not and over player? and if
    name swap pop
   else 
    pop
   then
  then
  .pmatch
  dup #-1 dbcmp if pop "NO VALID DB" else intostr then
  ptc !
 
  1 lines
  "You submitted the following information:" .tell
  "Name:              " n @ strcat .tell
  "tport command:     " tp @ strcat .tell
  "Player to contact: " ptc @ strcat " (" strcat ptc @ atoi dbref name strcat ")" strcat .tell
  1 lines
  "Is this correct? (y/n)" .tell
  READ STRIP tolower
  "y" stringpfx 1 = not if continue then
 
  1 lines
  "Enter a description now:" .tell
  1 lines
  "#" dbase intostr strcat "=" strcat listprop strcat
  no @ intostr strcat "/desc" strcat lsedit CALL
 
  dbase listprop no @ intostr strcat "/name" strcat n @ 0 addprop
  dbase listprop no @ intostr strcat "/tport" strcat tp @ 0 addprop
  dbase listprop no @ intostr strcat "/contact" strcat ptc @ 0 addprop
  "Entry successfully added." .tell
  break
 REPEAT
;
 
: editentry
  no !
 
  dbase listprop no @ strcat "/name" strcat getpropstr n !
  dbase listprop no @ strcat "/tport" strcat getpropstr tp !
  dbase listprop no @ strcat "/contact" strcat getpropstr ptc !
 
  1 lines
  "Edit entry #" no @ strcat ".  Type '.' any time to abort." strcat .tell
  1 lines
  "Current name : " n @ dup not if pop "NO NAME!" then strcat .tell
  "Enter new name or dbref, space to keep that one, or '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop exit then
  dup "#" stringpfx 1 = if 1 strcut swap pop then
  dup not if pop else
  dup atoi if
   dup atoi dbref dup ok? over #0 dbcmp not and over room? and if
    name swap pop
   else
    pop 
   then
  then
  n !
  then
  
  "Teleport command : " tp @ dup not if pop "NO TPORT!" then strcat .tell
  "Enter new tport destination, space to keep that one, or '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop exit then
  dup not if pop else tp ! then
  "Contact          : " ptc @ atoi dup not if pop "NO ONE!" else dbref name then strcat .tell
  "Enter new name or dbref, space to keep that one, or '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop exit then
  dup "#" stringpfx 1 = if 1 strcut swap pop then
  dup not if pop else
   dup atoi if
    dup atoi dbref dup ok? over #0 dbcmp not and over player? and if
     name swap pop
    else 
     pop
    then
   then
   .pmatch
   dup #-1 dbcmp if pop "0" else intostr then
   ptc !
  then
 
  "#" dbase intostr strcat "=" strcat listprop strcat no @ strcat
  "/desc" strcat lsedit CALL
 
  2 lines
  "You submitted the following information:" .tell
  1 lines
  "Name             : " n @ dup not if pop "NO NAME!" then strcat .tell
  "Teleport command : " tp @ dup not if pop "NO TPORT!" then strcat .tell
  "Contact          : " ptc @ atoi dup not if pop "NO ONE!" else dbref name then strcat .tell
 
  "Description:" .tell
  listprop no @ strcat "/desc#" strcat
  dbase over propdir? not if
   pop "NO DESCRIPTION AVAILABLE" .tell
  else
  "/" strcat
   1
   BEGIN
    over over
    intostr strcat dbase swap getpropstr dup while
    .tell
    1 +
   REPEAT
   pop pop pop
  then
  1 lines
  "Is all this correct? (y/n)" .tell
  READ STRIP tolower
  "y" stringpfx 1 = not if "Entry NOT changed!" .tell exit then
 
  dbase listprop no @ strcat "/name" strcat n @ 0 addprop
  dbase listprop no @ strcat "/tport" strcat tp @ 0 addprop
  dbase listprop no @ strcat "/contact" strcat ptc @ 0 addprop
  
  "Entry successfully changed!" .tell
;
 
: showlist
  BEGIN
   1 lines
   "Housing directory     " version strcat
   "  Maintained by " strcat
   maintainer dup " " instr strcut pop atoi dbref name strcat
   dup strlen swap .tell
   "" swap
   BEGIN
    dup while
    swap "~" strcat swap
    1 -
   REPEAT  
   pop .tell
   1 lines
   " #  | NAME                                      | How to get there   " .tell
   "----+-------------------------------------------+-----------------" .tell 
   1 existentry? not if
    "THE LIST IS EMPTY!" .tell
    me @ ismaintainer? not if break then
   then
    1
    BEGIN
     dup existentry? while
     dup intostr
     dup " " swap strcat 4 pad "| " strcat str !
     listprop swap strcat
     dbase swap
  
     over over "/name" strcat getpropstr
     dup not if pop "NO NAME!" then
     42 pad "| " strcat str @ swap strcat str !
  
     "/tport" strcat getpropstr
     dup not if pop "NO TPORT!" then
      str @ swap strcat str !
  
      1 +
     str @ .tell
    REPEAT
    pop
    1 lines
    me @ ismaintainer? not if
     "-- For more information type a number, or Q to quit."
    else
     "-- Type a number to edit, or Q to quit."
    then
    .tell
    READ STRIP tolower
    dup "q" stringpfx if pop break then
    dup "t" stringpfx if do-teleport exit then
    dup atoi existentry? not if
     me @ ismaintainer? not if
      pop "Invalid entry number, try again!" .tell
     else
      "No entry with that number exists. Add new one? (y/n)" .tell
      READ STRIP tolower
      "y" stringpfx 1 = if addentry then
      pop
     then
    else
     me @ ismaintainer? not if
      showdetails
     else
      "Do you want to <v>iew, <e>dit or <d>elete this entry? Q to quit." .tell
      READ STRIP tolower
      dup "v" stringpfx 1 = if pop showdetails continue then
      dup "d" stringpfx 1 = if pop atoi delentry continue then
      dup "e" stringpfx 1 = if pop editentry continue then
      pop pop
     then 
    
   then
  REPEAT
  1 lines
  "Find the home of your dreams today!" .tell
;

