$def HEADER "Lib-Debug.muf -- Syvel @ FurryFaire -- 18 Aug 1998"
( quick and dirty 'replacement' for Mystique's Lib-Debug, for mucks not blessed
  with that wonderful library.  This library is actually undergoing a fair bit
  of development and supports even more of the functionality of Mystique's
  Lib-Debug.  --Syvel 
 
  Functions provided:
    debugon       [   -- ] Set DEBUG flag on calling program.
    debugoff      [   -- ] Remove DEBUG flag on calling program.
    showstack     [ i -- ] Show i stack items to program owner.
    comment       [ s -- ] Show s comment to program owner.
    showvar       [ v -- ] show var or lvar v to program owner.
 
 [ I swiped the docs below from Mystique's library. --Syvel ]
 SHOWVAR setup:
 
 @set yourprogram=_Reg/Vars/xx:variable name
 @set yourprogram=_Reg/LVars/xx:variable name
 
 Showvar can distinguish the variables and produce names, but it can't read
 your program to get them.  The way they're counted is, normal VAR's start
 from 4 and go up <ones you define> from the beginning of your program.
 LVAR's start at 0 and go up, so:  Example fake program, showing variables.
 
 
 var myvariable            @set yourprogram=_Reg/Vars/4:myvariable
 var myname                @set yourprogram=_Reg/Vars/5:myname
 ...
 lvar temp                 @set yourprogram=_Reg/LVars/0:temp
 lvar cookies              @set yourprogram=_Reg/LVars/1:cookies
 ...
 
 If you don't setup registrations on your program for your variables, you'll
 get User Var #xx and User LVar #xx.
)
(
    Lib-Debug.muf -- Syvel @ FurryFaire -- 18 Aug 1998
    Copyright [c] 1998 Lawrence Cotnam Jr.
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    [at your option] any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
)
$include $lib/strings
$include $lib/case
 
lvar CALL-OWN
 
: leftfitstr ( str pad width - s )
  3 pick strlen over >= if swap pop strcut pop else
    3 pick -3 rotate STRfillfield strcat
  then
;
 
: rightfitstr ( str pad width - s )
  3 pick strlen over >= if swap pop strcut pop else
    3 pick -3 rotate STRfillfield swap strcat
  then
;
 
: centfitstr ( str pad width - s )
  3 pick strlen over >= if swap pop strcut pop else
    3 pick -3 rotate
    STRfillfield dup strlen 2 / strcut rot strcat swap strcat
  then
;
 
: tostring ( ? -- s ; convert anything to a string )
    dup case
        int? when
            intostr
        end
        string? when
            dup pop
        end
        dbref? when
            intostr "#" swap strcat
        end
        address? when
            intostr
        end
        lock? when
            dup pop
        end
        default
            pop intostr
        end
    endcase
;
 
: showstack ( i -- ; show i stack items. )
  caller owner dup CALL-OWN !
  "D-Bug> ___" notify
  dup depth > if pop depth then
  begin
    dup while
    dup 1 + pick
    dup int? if
      "D-Bug> " 3 pick intostr " " 2 leftfitstr strcat "..." strcat swap
      intostr strcat " (int)" strcat CALL-OWN @ swap notify
    else
      dup string? if
        "D-Bug> " 3 pick intostr " " 2 leftfitstr strcat "...\"" strcat swap
        strcat "\" (str)" strcat CALL-OWN @ swap notify
      else
        dup dbref? if
          "D-Bug> " 3 pick intostr " " 2 leftfitstr strcat "...#" strcat swap
          intostr strcat " (ref)" strcat CALL-OWN @ swap notify
        else
          address? if
            "D-Bug> " 3 pick intostr " " 2 leftfitstr strcat "..." strcat swap
            intostr strcat " (adr)" strcat CALL-OWN @ swap notify
          else
            lock? if
              "D-Bug> " 3 pick intostr " " 2 leftfitstr strcat "...\"" strcat
              swap strcat "\" (lock)" strcat CALL-OWN @ swap notify
            else
              "D-Bug> " 3 pick intostr " " 2 leftfitstr strcat
              "..." strcat swap intostr " (var)" strcat  CALL-OWN @ swap notify
            then
          then
        then
      then
    then
    1 -
  repeat pop
  CALL-OWN @ "D-Bug> ~~~" notify
;
 
: comment ( s -- ; show comment s )
  caller owner swap "D-Bug> " swap strcat notify
;
 
: debugon
  caller "D" set
;
 
: debugoff
  caller "!D" set
;
 
: parse-var ( i -- s ; return proper name for variable i )
    case
        0 = when
            "ME(0)"
        end
        1 = when
            "LOC(1)"
        end
        2 = when
            "TRIG(2)"
        end
        3 = when
            "COMMAND(3)"
        end
        default
            caller "_reg/vars/" 3 pick intostr strcat getpropstr dup if
                "(" strcat swap intostr strcat ")" strcat
            else
                pop "User Var " swap intostr strcat
            then
        end
    endcase
;
 
: parse-lvar ( i -- s ; return proper name for localvar i )
    intostr caller "_reg/lvars/" 3 pick strcat getpropstr dup if
        "(" strcat swap strcat ")" strcat
    else
        pop "User LVar " swap strcat
    then
;
 
: showvar ( v -- ; show variables or localvars from caller )
    "D-Bug> "
    over @ 3 pick intostr atoi variable @
    tostring swap tostring stringcmp if
        over intostr atoi parse-lvar
    else
        over intostr atoi parse-var
    then strcat "=" strcat
    swap @
    dup case
        int? when
            intostr " (int)" strcat
        end
        string? when
            " (str)" strcat
        end
        dbref? when
            intostr "#" swap strcat " (ref)" strcat
        end
        address? when
            intostr " (adr)" strcat
        end
        lock? when
            " (lock)" strcat
        end
        default
            pop intostr " (var)" strcat
        end
    endcase strcat caller owner swap notify
;
public showstack
public comment
public debugon
public debugoff
public showvar

