( purgelist.muf     by Gyroplast   06/18/99
  Generates a list of furs being not online
  for X days, sorted by time.
 
  Setup is simple, just link an action to the prog.
)
$def header " " .tell "  PurgeList v1.1  by Gyroplast" .tell "-------------------------------" .tell " " .tell
$def pad swap "                               " strcat swap strcut pop
lvar limit
lvar OnlyNeverConnected
: purge? ( i i -- b )
  systime swap - swap 86400 * >
;
 
: readdata
  "Retrieving database information, this might take a while..." .tell
  0
  BEGIN
  1 +
  dup dbtop int >= if pop break then
  dup
  dbref
  dup player? not if
    pop
   else  
    dup timestamps pop swap pop swap pop
    limit @ over purge? if
     trig -3 rotate
     intostr "VulpesVelox/" swap strcat swap intostr 0 addprop
    else
     pop pop
    then 
  then
  REPEAT
;
 
: showdata
  trig "VulpesVelox/"
  BEGIN
   nextprop
   dup while
   trig swap
   over over getpropstr atoi dbref
   dup name "  " swap strcat 18 pad "#" strcat over intostr strcat over
   timestamps
   not if
     pop pop pop ", Last on: NEVER CONNECTED  "
   else
     swap pop swap pop ", Last on: %a, %x  "
     swap timefmt
     ( check for _unused? prop )
     OnlyNeverConnected @ if
       pop pop pop continue
     then
   then
   strcat over
   timestamps pop pop pop
   "Created: %a, %x" swap timefmt strcat
   .tell
   pop
  REPEAT
  pop 
  " --=[ END OF LIST ]==-" .tell
;
 
: killdata
  trig "VulpesVelox" remove_prop
;
 
: showhelp
  header
  "  " trig name toupper " [#days]" strcat strcat .tell
  "  PurgeList assembles a list of idling furs for easy account termination." .tell
  " " .tell
  "  #days   -   every player not having connected for <#days> days will" .tell
  "              be shown in the list. If omitted, the default of" .tell
  "              60 days will be used." .tell
  " " .tell
;
  
: main
  dup not if pop "60" then
  dup "#" stringpfx 1 = if pop showhelp exit then
  atoi
  dup not if pop showhelp exit then
  dup 0 < if 
   pop 60 "Yeah, sure, a negative value." .tell
   "You really thought I wouldnt filter that? Assuming default now.." .tell
  then
  dup limit !
  intostr
  "All players not having connected for " swap strcat 
  " days will be shown." strcat .tell
  "Do you only want those to be shown who NEVER CONNECTED for that long? (y/n)"
  .tell
  begin
    read
    dup "y" stringpfx 1 = if
      pop 
      1 OnlyNeverConnected !
      "YES" .tell break
    then
    dup "n" stringpfx 1 = if
      pop 
      0 OnlyNeverConnected !
      "NO" .tell break
    then
    pop "Invalid response. Please type 'y' or 'n'." .tell
  repeat
  background
  readdata
  showdata
  killdata
;

