(
  broadcast.muf     by Gyroplast   04/30/2000   v0.8
  
  Broadcast poses/speech to other rooms.
  
  SETUP:
  ------
  WAY #1 FOR BEGINNERS:
     1. Write down the dbrefs of the rooms you want to broadcast
        to for later reference
     2. Create and link an action to this program;
          @action broadcast=me
          @link broadcast=<dbref of this program>
     3. Run 'broadcast #install' and follow the instructions.
  
  WAY #2 FOR PEOPLE WHO KNOW WHAT THEY'RE DOING:
     1. Set this prog on a _listen prop in the room you want to broadcast 
        *from*, preferably "_listen/broadcast" to make sure the automatic
        uninstallation will still work.
     2. Now set a space delimited dbref list of the rooms to broadcast *to*
        on the same room. Property name is "_broadcast/dests".
        No hashes required. dbref sanity check will be performed every run.
     3. Create an action on the broadcasting room; link to this program.
  
  After performing either of these steps the program will be enabled,
  and therefore broadcast speech and poses to the designated rooms.
  Type 'broadcast #help' in the room where you installed the program to
  get a list of options and other useful help.
  
  Have phun!
  *** check http://www.gyroplast.com for this and many other programs! ***
  *** This program is distributed under the GPL. Porting and mods      ***
  *** are explicitly allowed as long as this header stays intact, and  ***
  *** the result of any modification is distributed under the GPL.     ***
  *** For a detailed description of the DOs and DONTs, read the GPL at ***
  *** http://www.gyroplast.com/help/gpl.txt   --Thank you--            ***
)
( listen property to contain dbref of program )
$def listenprop "_listen/broadcast"
  
( header line with version and credits )
$def header "broadcast.muf v0.8 by Gyroplast@FuzzyLogic"
  
: strip-dup-spaces ( [ s -- s' ] - strips multiple spaces down to one )
  begin
    dup "  " instr while      ( still any two spaces in a row left? )
    " " "  " subst            ( Yup. Subst them with a single space )
  repeat
;
  
: is-disabled? ( [  -- b ] - check if broadcasting is disabled )
  trig "_broadcast/disabled" getprop
;
  
: filter-enabled? ( [  -- b ] - check if filtering is enabled )
  trig "_broadcast/filterenabled" getprop
;
  
: sanity-check ( [  --  ] - check properties for plausibility )
  trig "_broadcast/dests" getpropstr         ( get room listing )
  strip                                      ( no spaces please )
  strip-dup-spaces                           ( I dont want extra spaces! )
  "" "#" subst                               ( no hashes, either! )
  "" swap                                    ( placeholder for 'put' later )
  " " explode                                ( check the dbrefs 1 by 1 )
  begin                                      ( begin loop )
    dup while                                ( still dbrefs left? )
    1 - swap                                 ( uh huh. decrease count, go on )
    dup atoi dbref dup room? swap            ( is dbref a room? )
    owner trig owner dbcmp and if            ( is it owned by trigger owner? )
      " " strcat over 3 + pick swap strcat   ( get list, append new dbref )
      over 2 + put                           ( put list back )
    else                                     ( dbref is NOT a room )
      pop                                    ( just pop it off )
    then                                     ( and go on )
  repeat                                     ( lather, rinse, repeat )
  pop                                        ( dont need the explode count )
  striptail                                  ( there's a space at the end now )
  trig "_broadcast/dests" 3 rotate 0 addprop ( write new, checked prop back )
;
  
: filter-message ( [ s -- s' ] - process message s and return filtered s' )
  "" pop
;
  
: broadcast ( [ s --  ] - send message to rooms )
  trig "_broadcast/format" getpropstr  ( get broadcast format string )
  dup not if pop "In %l, %m" then      ( use default if prop not set )
  
  me @ location name "%l" subst        ( do substitution [location] )
  swap "%m" subst                      ( do substitution [message] )
  
  trig "_broadcast/dests" getpropstr   ( get list of rooms )
  " " explode                          ( explode it to process rooms 1 by 1 )
  begin                                ( begin loop )
    dup while                          ( still rooms left to process? )
    1 - swap                           ( Decrease counter, move room to top )
    atoi dbref                         ( room string -> dbref )
    depth pick #-1 swap                ( grab message from the depths of stack )
    notify_except                      ( show it to the whole room )
  repeat                               ( start over )
  pop pop                              ( cleanup the stack )
;
  
: do-unfiltered-broadcast ( [ s --  ] - broadcast s to rooms w/o filtering )
  sanity-check      ( do a sanity check of the room list )
  broadcast         ( it should be safe to broadcast the message now )
;
  
: do-filtered-broadcast ( [ s --  ] - broadcast s to rooms with filtering )
  sanity-check      ( sanity checking again )
  filter-message    ( now filter the message )
  broadcast         ( broadcast the safe AND filtered message now )
;
  
: show-help1 ( [  --  ] - show generic help screen )
  header .tell
;
  
: show-help2 ( [  --  ] - show not-so-generic help screen )
  header .tell
;
  
: activate-broadcast ( [  --  ] - activate broadcasting to other rooms )
  trig "_broadcast/disabled" remove_prop
;
  
: deactivate-broadcast ( [  --  ] - deactivate broadcasting to other rooms )
  trig "_broadcast/disabled" "true" 1 addprop
;
  
: activate-filter ( [  --  ] - activate broadcast filtering )
  trig "_broadcast/filterenabled" "true" 1 addprop
;
  
: deactivate-filter ( [  --  ] - deactivate broadcast filtering )
  trig "_broadcast/filterenabled" remove_prop
;
  
: do-install ( [  --  ] - do the first time installation )
  "" pop
;
  
: do-uninstall ( [  --  ] - entirely remove the broadcast program )
  "" pop
;
  
: mane
  trig room? if                    ( program run from _listen prop? )
    is-disabled? if pop exit then  ( broadcasting switched off? Quit! )
    filter-enabled? if             ( any filtering enable? )
      do-filtered-broadcast        ( Yup. Do filtered broadcast )
    else
      do-unfiltered-broadcast      ( Nah. Don't filter, just broadcast )
    then
  else                             ( program is being run by action )
    strip                          ( don't broadcast; check arguments instead )
    dup "#help" stringpfx 1 = if   ( show general help screen )
      pop show-help1
      exit
    then
    dup "#help2" stringpfx 1 = if  ( show filter help screen )
      pop show-help2
      exit
    then
    dup "#filteron" stringpfx 1 = if     ( activate filtering )
      pop activate-filter
      exit
    then
    dup "#filteroff" stringpfx 1 = if    ( deactivate filtering )
      pop deactivate-filter
      exit
    then
    dup "#on" stringpfx 1 = if     ( activate broadcasting )
      pop activate-broadcast
      exit
    then
    dup "#off" stringpfx 1 = if    ( deactivate broadcasting )
      pop deactivate-broadcast
      exit
    then
    dup "#inst" stringpfx 1 = if   ( install routine )
      pop do-install
      exit
    then
    dup "#uninst" stringpfx 1 = if ( uninstall routine )
      pop do-uninstall
      exit
    then
    pop show-help1                 ( unknown option; show general help )
  then
;

