(
  Piggybank.muf     by Gyroplast  12/16/98, revised 04/23/00
 
  Stores pennies 'in' an object. Cute.
  Needs wizbit to prevent unauthorized setting of storeprop.
 
  Setup:
    1. Create <object> to serve as penny container
    2. Link action attached to <object> to this program
    3. Run the action to get help
 
  Thats it, have phun!
  
  *** check http://www.gyroplast.com for this and many other programs! ***
  *** This program is distributed under the GPL. Porting and mods      ***
  *** are explicitly allowed as long as this header stays intact, and  ***
  *** the result of any modification is distributed under the GPL.     ***
  *** For a detailed description of the DOs and DONTs, read the GPL at ***
  *** http://www.gyroplast.com/help/gpl.txt   --Thank you--            ***
 
)
$def header " -- Piggybank v1.1 by Gyroplast --"
$def pennyprop "@pigbank"
 
: stripspaces  ( [ s -- s' ] - Strips multiple spaces in s down to one )
  dup "  " instr if " " "  " subst else exit then
  stripspaces   ( Yeah, TAIL recursion! ;)
;
 
: getstore   ( [  -- i ] - Get amount of stored pennies )
  trig location pennyprop getpropstr atoi
;
 
: maxpennies ( [  -- i ] - Get system parameter for max_pennies )
  "max_pennies" sysparm atoi
;
 
: open
        ( check if a mortal with LOTS of pennies wants even more )
  me @ pennies maxpennies > me @ "w" flag? not and if
    "As long as you have more pennies than you're allowed to anyway," .tell
    "you're certainly not going to touch your savings." .tell exit
  then
 
  me @ pennies getstore + maxpennies > me @ "w" flag? not AND 
  if  ( reached critical penny amount? ) 
    "Hmm.. seems like there are a more pennies stored in it than you" .tell
    "can carry in your pockets." .tell
    "You'd only get "
    maxpennies me @ pennies - intostr strcat " out of " strcat
    getstore intostr strcat " " strcat "pennies" sysparm strcat "." strcat
    .tell
    "Are you sure you want to break the "
    trig location name strcat " for that? (yes/no)" strcat .tell
  else
    "Are you sure you want to break the "
    trig location name strcat " for " strcat getstore intostr strcat
    " " strcat "pennies" sysparm strcat "? (yes/no)" strcat .tell
  then  
 
  read strip
  "y" stringpfx 1 = not if  ( the wuss doesnt want to break it anymore! )
    "You put the " trig location name strcat " back." strcat .tell exit
  then
          ( checking done, now give the fur it's pennies... )
  "You break the " trig location name strcat ", and find " strcat
  getstore intostr strcat
  " " strcat "pennies" sysparm strcat "!" strcat .tell
          ( check if pennies+purse would exceed max_pennies )
  me @ pennies getstore + maxpennies > me @ "w" flag? not and if
    "Unfortunately you can't carry all of them, so you grab only "
    maxpennies me @ pennies - dup intostr swap -3 rotate strcat
    " of them." strcat .tell
  else            ( if it doesnt, add the full amount )
    getstore
  then
  me @ swap addpennies
  trig location recycle    ( recycle the piggybank object )
;
 
: check
  "You guess that there must be around " getstore intostr strcat
  " " strcat "pennies" sysparm strcat " in the " strcat
  trig location name strcat "." strcat .tell
;
 
: store  ( [ i --  ] - Store i pennies on object )
  dup not if pop          ( 0 or invalid value ) 
    "If you don't want to save any coins, why are you typing this?" .tell exit 
  then
  dup 1 < if pop          ( negative pennies 'exploit'. ;)
    "Silly... how would you store a negative amount of pennies?"
    .tell exit 
  then
  me @ pennies over < if  ( the poor fur can't save that much.. )
    "You don't own that many pennies!" .tell exit 
  then
        ( all sanity checks passed, now let's store the cash )
  "You put " over intostr strcat " " strcat "pennies" sysparm strcat
  " into the " strcat trig location name strcat "." strcat .tell
  getstore over + intostr      ( add i to old amount )
  trig location swap pennyprop swap 0 addprop  ( set the new prop value )
  -1 * me @ swap addpennies    ( substract the stored pennies from purse )
;
 
: help
  header .tell
  " " .tell
  "  #open        -  Destroys the object and releases the stored amount" .tell
  "                  of pennies." .tell
  "  #store <#>   -  Stores <#> pennies in the object." .tell
  "  #check       -  Tells you how many pennies are stored at the moment." .tell
  " ".tell
;
 
: main
  strip
  dup not if pop help exit then                  ( no parameters? Show help! )
  dup "#h" stringpfx if pop help exit then       ( #HELP  )
  dup "#o" stringpfx if pop open exit then       ( #OPEN  )
  dup "#c" stringpfx if pop check exit then     ( #CHECK )
  dup "#s" stringpfx if 
    stripspaces                  ( delete extra spaces )
    dup " " instr dup not if     ( are there 2 args? )
      pop pop help exit          ( if not, bail out and show help )
    else
      strcut swap pop atoi store ( otherwise pass second arg to word )
    then
  else 
    help exit                    ( not a known command, display help )
  then
;

